﻿using System;
using System.Windows;
using System.Windows.Resources;
using System.Text;
using System.IO;
using System.Collections.Generic;

namespace NLipsum.WindowsPhone
{
    /// <summary>
    /// Compatibility layer for WP7 added by Dan Clarke
    /// </summary>
    internal static class Resources
    {
        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-1&quot;?&gt;
        ///
        ///&lt;!-- This is a template file for custom lipsum texts --&gt;
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;Childe Harold&apos;s Pilgrimage - Canto the first (I.-X.)&lt;/title&gt;
        ///    &lt;author&gt;Lord Byron&lt;/author&gt;
        ///    &lt;text&gt;
        ///	oh thou in hellas deemed of heavenly birth
        ///	muse formed or fabled at the minstrels will
        ///	since shamed full oft by later lyres on earth
        ///	mine dares not call thee from thy sacred hill
        ///	yet there ive wandered by thy  [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string ChildHarold { get { return GetXmlContent("childharold.xml"); } }

        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-1&quot;?&gt;
        ///
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;Decameron - Novella Prima&lt;/title&gt;
        ///    &lt;author&gt;Giovanni Boccaccio&lt;/author&gt;
        ///    &lt;text&gt;
        ///	convenevole cosa e carissime donne che ciascheduna cosa la quale l&apos;uomo fa dallo ammirabile e santo nome di colui il quale di tutte fu facitore le dea principio per che dovendo io al vostro novellare sí come primo dare cominciamento intendo da una delle sue maravigliose cose incominciare accio [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string Decameron { get { return GetXmlContent("decameron.xml"); } }

        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-1&quot;?&gt;
        ///
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;Faust: Der Tragödie erster Teil&lt;/title&gt;
        ///    &lt;author&gt;Johann Wolfgang von Goethe&lt;/author&gt;
        ///    &lt;text&gt;
        ///	ihr naht euch wieder schwankende gestalten
        ///	die früh sich einst dem trüben blick gezeigt
        ///	versuch ich wohl euch diesmal festzuhalten
        ///	fühl ich mein herz noch jenem wahn geneigt
        ///	ihr drängt euch zu  nun gut so mögt ihr walten
        ///	wie ihr aus dunst und nebel um mich steigt
        ///	mein [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string Faust { get { return GetXmlContent("faust.xml"); } }

        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-1&quot;?&gt;
        ///
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;In der Fremde&lt;/title&gt;
        ///    &lt;author&gt;Heinrich Heine&lt;/author&gt;
        ///    &lt;text&gt;
        ///	es treibt dich fort von ort zu ort
        ///	du weißt nicht mal warum
        ///	im winde klingt ein sanftes wort
        ///	schaust dich verwundert um
        ///
        ///	die liebe die dahinten blieb
        ///	sie ruft dich sanft zurück
        ///	o komm zurück ich hab dich lieb
        ///	du bist mein einz&apos;ges glück
        ///
        ///	doch weiter weiter sonder rast
        ///	du darfst nicht still [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string InDerFremde { get { return GetXmlContent("inderfremde.xml"); } }

        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-2&quot;?&gt;
        ///
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;Le Bateau Ivre&lt;/title&gt;
        ///    &lt;author&gt;Arthur Baudelaire&lt;/author&gt;
        ///    &lt;text&gt;
        ///	comme je descendais des fleuves impassibles
        ///	je ne me sentis plus guidé par les haleurs 
        ///	des peaux-rouges criards les avaient pris pour cibles
        ///	les ayant cloués nus aux poteaux de couleurs
        ///
        ///	j&apos;étais insoucieux de tous les équipages
        ///	porteur de blés flamands ou de cotons anglais
        ///	quand avec mes hal [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string LeBateauIvre { get { return GetXmlContent("lebateauivre.xml"); } }

        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-2&quot;?&gt;
        ///
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;Le Masque&lt;/title&gt;
        ///    &lt;author&gt;Arthur Rembaud&lt;/author&gt;
        ///    &lt;text&gt;
        ///	contemplons ce trésor de grâces florentines
        ///	dans l&apos;ondulation de ce corps musculeux
        ///	l&apos;elégance et la force abondent soeurs divines
        ///	cette femme morceau vraiment miraculeux
        ///	divinement robuste adorablement mince
        ///	est faite pour trôner sur des lits somptueux
        ///	et charmer les loisirs d&apos;un pontife ou d&apos;un prin [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string LeMasque { get { return GetXmlContent("lemasque.xml"); } }

        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-1&quot;?&gt;
        ///
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;Lorem ipsum&lt;/title&gt;
        ///    &lt;author&gt;Cicero&lt;/author&gt;
        ///    &lt;text&gt;
        ///	lorem ipsum dolor sit amet consetetur sadipscing elitr sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat sed diam voluptua at vero eos et accusam et justo duo dolores et ea rebum stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet lorem ipsum dolor sit amet cons [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string LoremIpsum { get { return GetXmlContent("loremipsum.xml"); } }

        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-2&quot;?&gt;
        ///
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;Nagyon fáj&lt;/title&gt;
        ///    &lt;author&gt;József Attila&lt;/author&gt;
        ///    &lt;text&gt;
        ///	kivül belõl
        ///	leselkedõ halál elõl
        ///	mint lukba megriadt egérke
        ///
        ///	amíg hevülsz
        ///	az asszonyhoz úgy menekülsz
        ///	hogy óvjon karja öle térde
        ///
        ///	nemcsak a lágy
        ///	meleg öl csal nemcsak a vágy
        ///	de odataszít a muszáj is
        ///
        ///	ezért ölel
        ///	minden ami asszonyra lel
        ///	míg el nem fehérül a száj is
        ///
        ///	kettõs teher
        ///	s ket [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string NagyonFaj { get { return GetXmlContent("nagyonfaj.xml"); } }

        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-2&quot;?&gt;
        ///
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;Ómagyar-Mária siralom&lt;/title&gt;
        ///    &lt;author&gt;Ismeretlen&lt;/author&gt;
        ///    &lt;text&gt;
        ///	volek syrolm thudothlon syrolmol sepedyk buol ozuk epedek walasth vylagumtul sydou fyodumtul ezes urumemtuul o en eses urodum eggen yg fyodum syrou aniath thekunched buabeleul kyniuhhad scemem kunuel arad en iunhum buol farad the werud hullothya en iunhum olelothya vylag uilaga viragnac uiraga keseruen ky [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string Omagyar { get { return GetXmlContent("omagyar.xml"); } }

        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-2&quot;?&gt;
        ///
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;Robinsono Kruso (Esperanto)&lt;/title&gt;
        ///    &lt;author&gt;Daniel Defoe&lt;/author&gt;
        ///    &lt;text&gt;
        ///	mi naskigxis en jorko anglujo je marto   kiu estas la
        ///	sesjarrego de la regxo karolo la unua infane mi sentadis grandan
        ///	deziron por pasigi mian vivon sur la maro kaj pliagxante la deziro
        ///	plifortigxis gxis fine mi forlasis mian lernejon kaj hejmon kaj
        ///	piede mi trovis mian vojon al hull kie m [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string RobinsonoKruso { get { return GetXmlContent("robinsonokruso.xml"); } }

        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-1&quot;?&gt;
        ///
        ///&lt;!-- This is a template file for custom lipsum texts --&gt;
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;The Raven&lt;/title&gt;
        ///    &lt;author&gt;Edgar Allan Poe&lt;/author&gt;
        ///    &lt;text&gt;
        ///	once upon a midnight dreary while i pondered weak and weary
        ///	over many a quaint and curious volume of forgotten lore
        ///	while i nodded nearly napping suddenly there came a tapping
        ///	as of some one gently rapping rapping at my chamber door
        ///	tis some visit [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string TheRaven { get { return GetXmlContent("theraven.xml"); } }

        /// <summary>
        ///   Looks up a localized string similar to &lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-2&quot;?&gt;
        ///
        ///&lt;lipsum&gt;
        ///    &lt;copyright&gt;This text is under public domain&lt;/copyright&gt;
        ///    &lt;title&gt;Tierra y Luna&lt;/title&gt;
        ///    &lt;author&gt;Federico García Lorca&lt;/author&gt;
        ///    &lt;text&gt;
        ///	me quedo con el transparente hombrecillo
        ///	que come los huevos de la golondrina
        ///	me quedo con el nino desnudo
        ///	que pisotean los borrachos de brooklyn
        ///	con las criaturas mudas que pasan bajo los arcos
        ///	con el arroyo de venas ansioso de abrir sus manecitas
        ///
        ///	tierra tan sólo tierra
        ///	tierra para los [rest of string was truncated]&quot;;.
        /// </summary>
        internal static string TierrayLuna { get { return GetXmlContent("tierrayluna.xml"); } }

        /// <summary>
        /// Get XML file content for the specified filename, content is assumed to be a resource embedded in the dll
        /// </summary>
        /// <param name="filename">Filename</param>
        /// <returns></returns>
        /// <remarks>It would be more efficient to open the stream and use in the utilities class, but
        /// that would lose compat with the existing code base</remarks>
        private static string GetXmlContent(string filename)
        {
            StreamResourceInfo xmlResource = Application.GetResourceStream(new Uri("/NLipsum.WindowsPhone;component/resources/" + filename, UriKind.Relative));
            string output = string.Empty;

            using (Stream stream = xmlResource.Stream)
            {
                using (StreamReader reader = new StreamReader(stream))
                {
                    output = reader.ReadToEnd();
                }
            }

            return output;
        }
    }
}
